/*
 * @Author: fengbo
 * @Date:   2017-04-24 16:45:50
 * @Last Modified by:   fengbo
 * @Last Modified time: 2017-06-08 14:35:21
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _jss = require('jss');

var _jss2 = _interopRequireDefault(_jss);

var _jssPresetDefault = require('jss-preset-default');

var _jssPresetDefault2 = _interopRequireDefault(_jssPresetDefault);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

_jss2.default.setup((0, _jssPresetDefault2.default)());

function getStyles(props, context, state) {
  var baseTheme = context.muiTheme.baseTheme;

  var symbol = props.separator === 'arrow' ? '">"' : '"/"';
  var styles = {
    root: {
      listStyle: 'none',
      color: '#777',
      margin: 0
    },
    breadcrumb_item: {
      float: 'left',
      textTransform: 'capitalize',
      textDecoration: 'none',
      '&:not(:last-child):after': {
        content: symbol,
        paddingRight: '.5rem',
        paddingLeft: '.5rem'
      }
    }
  };
  return styles;
}

var Breadcrumb = function (_React$Component) {
  _inherits(Breadcrumb, _React$Component);

  function Breadcrumb(props) {
    _classCallCheck(this, Breadcrumb);

    return _possibleConstructorReturn(this, (Breadcrumb.__proto__ || Object.getPrototypeOf(Breadcrumb)).call(this, props));
  }

  _createClass(Breadcrumb, [{
    key: 'render',
    value: function render() {
      var styles = getStyles(this.props, this.context, this.state);

      var _jss$createStyleSheet = _jss2.default.createStyleSheet(styles).attach(),
          classes = _jss$createStyleSheet.classes;

      var _props = this.props,
          style = _props.style,
          children = _props.children,
          className = _props.className;

      var childrenDom = _react2.default.Children.map(children, function (child, index) {
        if (!child) {
          return child;
        }
        return _react2.default.createElement(
          'li',
          { className: classes.breadcrumb_item, key: index },
          child
        );
      });

      return _react2.default.createElement(
        'ol',
        { style: Object.assign(styles.root, style), className: className },
        childrenDom
      );
    }
  }]);

  return Breadcrumb;
}(_react2.default.Component);

Breadcrumb.propTypes = {
  /**
   * 样式 
   */
  style: _react2.default.PropTypes.object,
  /**
   * 类名
   */
  className: _react2.default.PropTypes.string,
  /**
   * 子元素
   */
  children: _react2.default.PropTypes.any,
  /**
   * 分割符，目前支持2种,箭头arrow和斜线slash
   */
  separator: _react2.default.PropTypes.oneOf(['arrow', 'slash'])
};
Breadcrumb.defaultProps = {
  separator: 'arrow'
};
Breadcrumb.contextTypes = {
  muiTheme: _react2.default.PropTypes.object.isRequired
};
exports.default = Breadcrumb;