'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _RangeDatePickerDialog = require('./RangeDatePickerDialog');

var _RangeDatePickerDialog2 = _interopRequireDefault(_RangeDatePickerDialog);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _DatePickerDialog = require('./DatePickerDialog');

var _DatePickerDialog2 = _interopRequireDefault(_DatePickerDialog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props, context) {
  var _context$muiTheme = context.muiTheme,
      palette = _context$muiTheme.palette,
      datePicker = _context$muiTheme.datePicker;

  return {
    reportTimePlugin: {
      right: 0,
      top: 0,
      position: "relative",
      zIndex: 230,
      display: "inline-block",
      maxWidth: '370px',
      textAlign: 'left',
      background: datePicker.calendarYearBackgroundColor
      // paddingLeft: "20px"
    },
    choiceDatePicker_menu: {
      height: '30px',
      position: 'relative',
      // background: 'rgb(0, 151, 167)',
      borderRadius: '3px',
      cursor: 'pointer',
      // color: '#fff',
      padding: '0 5px',
      lineHeight: '30px',
      border: '1px solid #d1d5d8'
      // border:
    },
    p: {
      padding: 0,
      margin: 0,
      fontStyle: 'normal'
    },
    icon: {
      width: '11px',
      height: '6px',
      display: 'block',
      position: 'absolute',
      top: '11px',
      right: '10px',
      zIndex: 10
    },
    calendar: {
      marginRight: '10px',
      fontSize: '16px'
    }
  };
}

var RangeDatePicker = function (_Component) {
  _inherits(RangeDatePicker, _Component);

  function RangeDatePicker(props) {
    _classCallCheck(this, RangeDatePicker);

    var _this = _possibleConstructorReturn(this, (RangeDatePicker.__proto__ || Object.getPrototypeOf(RangeDatePicker)).call(this, props));

    _this.state = {
      choicedValue: '请选择时间',
      beginDate: null,
      endDate: null
    };
    return _this;
  }

  _createClass(RangeDatePicker, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var choiceDatePickerDialog = _reactDom2.default.findDOMNode(this.refs.choiceDatePickerDialog);
      choiceDatePickerDialog.style.display = "none";
      this.setDate(this.props.initDate);
    }
    //根据props中传入的时间范围计算出开始时间和结束时间

  }, {
    key: 'setDate',
    value: function setDate(initDate) {
      var beginDate = void 0,
          endDate = void 0,
          choicedValue = void 0;
      choicedValue = initDate;
      this.setState({
        choicedValue: choicedValue
      });
      this.refs.choiceDatePickerDialog.setDefaultDate(new Date(initDate));
    }
  }, {
    key: 'handleOnClick',
    value: function handleOnClick(e) {
      var choiceDatePickerDialog = _reactDom2.default.findDOMNode(this.refs.choiceDatePickerDialog);
      choiceDatePickerDialog.style.display === "none" ? choiceDatePickerDialog.style.display = "block" : choiceDatePickerDialog.style.display = "none";
    }
  }, {
    key: 'handleClickClose',
    value: function handleClickClose(stateData, beginDate, endDate) {
      var choiceDatePickerDialog = _reactDom2.default.findDOMNode(this.refs.choiceDatePickerDialog);
      choiceDatePickerDialog.style.display = "none";
      stateData && this.setState({
        choicedValue: stateData
      });
      this.props.choiceDate(stateData);
    }
  }, {
    key: 'getSelectedTime',
    value: function getSelectedTime() {
      return {
        selectDate: this.state.stateData
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var styles = getStyles(this.props, this.context);
      var _props = this.props,
          style = _props.style,
          dialogStyle = _props.dialogStyle,
          showHourMinutesSilder = _props.showHourMinutesSilder;

      return _react2.default.createElement(
        'div',
        { style: style },
        _react2.default.createElement(
          'div',
          { style: styles.reportTimePlugin },
          _react2.default.createElement(
            'div',
            { style: styles.choiceDatePicker_menu, onClick: this.handleOnClick.bind(this) },
            _react2.default.createElement(_reactFontawesome2.default, { style: styles.calendar, name: 'calendar' }),
            _react2.default.createElement(
              'span',
              { style: styles.p },
              this.state.choicedValue
            )
          ),
          _react2.default.createElement(_DatePickerDialog2.default, {
            style: dialogStyle,
            ref: 'choiceDatePickerDialog',
            onClose: this.handleClickClose.bind(this)
          })
        )
      );
    }
  }]);

  return RangeDatePicker;
}(_react.Component);

RangeDatePicker.propTypes = {
  /**
   * 初始时间,最好从组件提供的几个时间点来选择
   * @type {[string]}
   */
  initDate: _react2.default.PropTypes.any,
  /**
   * style
   * @type {[type]}
   */
  style: _react2.default.PropTypes.object,
  /**
   * dialogSty;e
   * @type {[type]}
   */
  dialogStyle: _react2.default.PropTypes.object,
  /**
   * 选择时间后触发事件
   * @type {[type]}
   */
  choiceDate: _react2.default.PropTypes.func,
  /**
   * 是否显示小时和分钟的拉动条
   * @type {[type]}
   */
  showHourMinutesSilder: _react2.default.PropTypes.bool
};
RangeDatePicker.defaultProps = {
  initDate: '近7天',
  showHourMinutesSilder: false
};
RangeDatePicker.contextTypes = {
  muiTheme: _react2.default.PropTypes.object.isRequired
};
exports.default = RangeDatePicker;