'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _keycode = require('keycode');

var _keycode2 = _interopRequireDefault(_keycode);

var _styleMerge = require('style-merge');

var _styleMerge2 = _interopRequireDefault(_styleMerge);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _Calendar = require('./Calendar');

var _Calendar2 = _interopRequireDefault(_Calendar);

var _dateUtils = require('material-ui/DatePicker/dateUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DatePickerDialog = function (_Component) {
  _inherits(DatePickerDialog, _Component);

  function DatePickerDialog() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DatePickerDialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DatePickerDialog.__proto__ || Object.getPrototypeOf(DatePickerDialog)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: false,
      initialDate: new Date()
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DatePickerDialog, [{
    key: 'handleChangeMaxDate',
    value: function handleChangeMaxDate(date) {
      this.setState({
        initialDate: date
      });
    }
  }, {
    key: 'setDefaultDate',
    value: function setDefaultDate(beginDate) {
      this.setState({
        initialDate: beginDate
      });
    }
  }, {
    key: 'onTouchTapDay',
    value: function onTouchTapDay(e, date) {
      var selectDate = this.subDate(date);
      this.props.onClose(selectDate);
    }
  }, {
    key: 'subDate',
    value: function subDate(baseDate) {
      var month = this.formatTime(baseDate.getMonth() + 1);
      var day = this.formatTime(baseDate.getDate());
      var val = baseDate.getFullYear() + "-" + month + "-" + day;
      return val;
    }
  }, {
    key: 'formatTime',
    value: function formatTime(number) {
      if (number < 10) {
        number = "0" + number;
      }
      return number;
    }
  }, {
    key: 'render',
    value: function render() {
      var style = this.props.style;
      var datePicker = this.context.muiTheme.datePicker;

      var styles = {
        choiceDatePicker_box: {
          border: 'solid 1px #c0c0c0',
          background: datePicker.calendarYearBackgroundColor,
          position: 'absolute',
          top: '36px',
          width: '312px',
          display: 'block'
        },
        choiceDatePicker_head: {
          // borderBottom: '#c0c0c0 solid 1px',
          height: '36px',
          marginLeft: '13px',
          marginRight: '13px',
          lineHeight: '36px'
        },
        title: {
          fontWeight: 'bold',
          float: 'left'
        },
        time_selection_close: {
          float: 'right',
          marginTop: '10px',
          width: '20px',
          height: '20px',
          marginRight: '-10px',
          fontSize: '16px',
          cursor: 'pointer'
        }
      };

      return _react2.default.createElement(
        'div',
        { style: (0, _styleMerge2.default)(styles.choiceDatePicker_box, style) },
        _react2.default.createElement(_Calendar2.default, {
          autoOk: true,
          firstDayOfWeek: 1,
          initialDate: this.state.initialDate,
          getState: this.handleChangeMaxDate.bind(this),
          onTouchTapDay: this.onTouchTapDay.bind(this),
          ref: 'maxCalendar'
        })
      );
    }
  }]);

  return DatePickerDialog;
}(_react.Component);

DatePickerDialog.propTypes = {
  /**
   * [style description]
   * @type {[type]}
   */
  style: _react.PropTypes.object
};
DatePickerDialog.contextTypes = {
  muiTheme: _react.PropTypes.object.isRequired
};
exports.default = DatePickerDialog;