'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.getStyles = getStyles;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Toggle = require('material-ui/Toggle');

var _Toggle2 = _interopRequireDefault(_Toggle);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _RaisedButton = require('material-ui/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _styleMerge = require('style-merge');

var _styleMerge2 = _interopRequireDefault(_styleMerge);

var _dateUtils = require('material-ui/DatePicker/dateUtils');

var _Calendar = require('./Calendar');

var _Calendar2 = _interopRequireDefault(_Calendar);

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _RecentTime = require('./RecentTime');

var _RecentTime2 = _interopRequireDefault(_RecentTime);

var _DatePicker = require('./DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getStyles(props, context) {
  var datePicker = context.muiTheme.datePicker;

  return {
    choiceDatePicker_box: {
      border: 'solid 1px #c0c0c0',
      background: datePicker.calendarYearBackgroundColor,
      position: 'absolute',
      top: '36px',
      width: '625px',
      display: 'block'
    },
    choiceDatePicker_head: {
      borderBottom: '#c0c0c0 solid 1px',
      height: '36px',
      marginLeft: '13px',
      marginRight: '13px',
      lineHeight: '36px'
    },
    title: {
      fontWeight: 'bold',
      float: 'left'
    },
    time_selection_close: {
      float: 'right',
      marginTop: '10px',
      width: '20px',
      height: '20px',
      marginRight: '-10px',
      fontSize: '16px',
      cursor: 'pointer'
    },
    choiceDatePicker_tab_header: {
      textAlign: 'right',
      paddingRight: '18px',
      height: '40px',
      lineHeight: '40px'
    },
    change_tab: {
      width: '50px',
      height: '16px',
      display: 'inline-block',
      position: 'relative'
    },
    toggle: {
      // marginBottom: 16,
    },
    floatLeft: {
      float: "left"
    },
    tab_content: {
      margin: '10px 0 30px 0',
      display: 'none'
    },
    clear: { //清浮动
      clear: 'both',
      height: 0,
      lineHeight: 0,
      fontSize: 0
    },
    footerToolContainerStyle: Object.assign({}, {
      textAlign: 'center',
      marginTop: '20px'
    }, props.footerToolContainerStyle),
    footerToolOkButtonStyle: Object.assign({}, {
      color: '#fff'
    }, props.footerToolOkButtonStyle),
    footerToolCancleButtonStyle: Object.assign({}, {
      backgroundColor: 'rgb(233, 232, 232)'
    }, props.footerToolCancleButtonStyle)
  };
}

var ChoiceDatePickerDialog = function (_Component) {
  _inherits(ChoiceDatePickerDialog, _Component);

  function ChoiceDatePickerDialog(props) {
    _classCallCheck(this, ChoiceDatePickerDialog);

    var _this = _possibleConstructorReturn(this, (ChoiceDatePickerDialog.__proto__ || Object.getPrototypeOf(ChoiceDatePickerDialog)).call(this, props));

    _this.formatDate = function (date) {
      if (_this.props.locale) {
        var DateTimeFormat = _this.props.DateTimeFormat || _dateUtils.dateTimeFormat;
        return new DateTimeFormat(_this.props.locale, {
          day: 'numeric',
          month: 'numeric',
          year: 'numeric'
        }).format(date);
      } else {
        return (0, _dateUtils.formatIso)(date);
      }
    };

    var minDate = new Date();
    var maxDate = new Date();
    minDate.setFullYear(minDate.getFullYear() - 1);
    minDate.setHours(0, 0, 0, 0);
    maxDate.setFullYear(maxDate.getFullYear() + 1);
    maxDate.setHours(0, 0, 0, 0);
    _this.state = {
      minDate: minDate,
      maxDate: maxDate,
      choicedValue: '请选择时间范围'
    };
    // console.log(this.subDate(2,1,40));
    return _this;
  }

  _createClass(ChoiceDatePickerDialog, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var recentlyTime = _reactDom2.default.findDOMNode(this.refs.recently_time);
      var assignTime = _reactDom2.default.findDOMNode(this.refs.assign_time);
      recentlyTime.style.display = "block";
    }
  }, {
    key: 'handlerOnToggle',
    value: function handlerOnToggle() {
      var recentlyTime = _reactDom2.default.findDOMNode(this.refs.recently_time);
      var assignTime = _reactDom2.default.findDOMNode(this.refs.assign_time);
      if (recentlyTime.style.display === "none") {
        recentlyTime.style.display = "block";
        assignTime.style.display = "none";
      } else {
        recentlyTime.style.display = "none";
        assignTime.style.display = "block";
      }
    }
  }, {
    key: 'choiceOnClick',
    value: function choiceOnClick(e) {
      this.setState({
        choicedValue: e.target.textContent
      });
      var endDate = new Date();
      var beginDate = this.getBeginDate(e.target.textContent, endDate);
      endDate = this.subDate(null, null, null, endDate);
      this.props.onClose(e.target.textContent, beginDate, endDate);
    }
  }, {
    key: 'getBeginDate',
    value: function getBeginDate(content, nowDate) {
      var M = new RegExp(/分/).test(content);
      var H = new RegExp(/小时/).test(content);
      var D = new RegExp(/天/).test(content);
      var week = new RegExp(/周/).test(content);
      var month = new RegExp(/月/).test(content);
      var halfMonth = new RegExp(/半个月/).test(content);
      var number = content.match(/\d+/g) && content.match(/\d+/g).toString();
      if (week) {
        D = true;
        number = number * 7;
      } else if (halfMonth) {
        D = true;
        number = 15;
      } else if (month) {
        D = true;
        number = number * 30;
      }
      return this.subDate(D && number, H && number, M && number, nowDate);
    }
    /**
     * 向前推移时间通用方法
     * @param  {[type]} days     [description]
     * @param  {[type]} hours    [description]
     * @param  {[type]} minutes  [description]
     * @param  {[type]} baseDate [description]
     * @return {[type]}          [description]
     */

  }, {
    key: 'subDate',
    value: function subDate(days, hours, minutes, baseDate) {
      var showHourMinutesSilder = this.props.showHourMinutesSilder;

      baseDate = baseDate || new Date();
      var d = new Date(baseDate);
      // months && d.setDate(d.getDate() - 30 * month + 1);
      // weeks && d.setDate(d.getDate() - 7 * week + 1);
      days && d.setDate(d.getDate() - days + 1);
      hours && d.setHours(d.getHours() - hours);
      minutes && d.setMinutes(d.getMinutes() - minutes);
      var month = this.formatTime(d.getMonth() + 1);
      var day = this.formatTime(d.getDate());
      var HH = this.formatTime(d.getHours());
      var MM = this.formatTime(d.getMinutes());
      var ss = this.formatTime(d.getSeconds());
      var valIsHMS = d.getFullYear() + "-" + month + "-" + day + ' ' + HH + ':' + MM + ':' + ss; // 显示时分秒
      var valIsnotHMS = d.getFullYear() + "-" + month + "-" + day; //不显示时分秒
      return showHourMinutesSilder || hours || minutes ? valIsHMS : valIsnotHMS;
    }
  }, {
    key: 'formatTime',
    value: function formatTime(number) {
      if (number < 10) {
        number = "0" + number;
      }
      return number;
    }
  }, {
    key: 'handleChangeMinDate',
    value: function handleChangeMinDate(date) {
      this.setState({
        minDate: date
      });
    }
  }, {
    key: 'handleChangeMaxDate',
    value: function handleChangeMaxDate(date) {
      this.setState({
        maxDate: date
      });
    }
  }, {
    key: 'setDefaultDate',
    value: function setDefaultDate(beginDate, endDate) {
      this.setState({
        minDate: beginDate,
        maxDate: endDate
      });
    }
  }, {
    key: 'setOnClick',
    value: function setOnClick() {
      var showHourMinutesSilder = this.props.showHourMinutesSilder;

      var minCalendar = this.refs.minCalendar.getSelectedDate();
      var minTime = showHourMinutesSilder && this.refs.minCalendar.getSelectTime() || '';
      var maxCalendar = this.refs.maxCalendar.getSelectedDate();
      var maxTime = showHourMinutesSilder && this.refs.maxCalendar.getSelectTime() || '';
      var beginDate = this.formatDate(minCalendar) + ' ' + minTime;
      var endDate = this.formatDate(maxCalendar) + ' ' + maxTime;
      var value = beginDate + ' 至 ' + endDate;
      this.setState({
        choicedValue: value
      });
      this.props.onClose(value, beginDate, endDate);
    }
  }, {
    key: 'onClose',
    value: function onClose() {
      this.props.onClose();
    }
  }, {
    key: 'getState',
    value: function getState(data) {
      console.log(data);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var datePicker = this.context.muiTheme.datePicker;

      var styles = getStyles(this.props, this.context);
      var _props = this.props,
          onClose = _props.onClose,
          style = _props.style,
          footerCancleButtonText = _props.footerCancleButtonText,
          footerOkButtonText = _props.footerOkButtonText,
          showHourMinutesSilder = _props.showHourMinutesSilder;

      return _react2.default.createElement(
        'div',
        { style: (0, _styleMerge2.default)(styles.choiceDatePicker_box, style) },
        _react2.default.createElement(
          'div',
          { style: styles.choiceDatePicker_head },
          _react2.default.createElement(
            'span',
            { style: styles.title },
            '\u9009\u62E9\u65F6\u95F4'
          ),
          _react2.default.createElement(_reactFontawesome2.default, { style: styles.time_selection_close, name: 'close', onClick: function onClick() {
              return _this2.props.onClose(_this2.state.choicedValue);
            } })
        ),
        _react2.default.createElement(
          'div',
          { style: styles.choiceDatePicker_tab_header },
          _react2.default.createElement(
            'span',
            null,
            "最近"
          ),
          _react2.default.createElement(
            'div',
            { style: styles.change_tab },
            _react2.default.createElement(_Toggle2.default, {
              style: styles.toggle,
              onToggle: this.handlerOnToggle.bind(this)
            })
          ),
          _react2.default.createElement(
            'span',
            null,
            "指定时间"
          )
        ),
        _react2.default.createElement(
          'div',
          { style: styles.tab_content, ref: 'recently_time' },
          _react2.default.createElement(_RecentTime2.default, {
            onClick: this.choiceOnClick.bind(this)
          })
        ),
        _react2.default.createElement(
          'div',
          { style: styles.tab_content, ref: 'assign_time' },
          _react2.default.createElement(
            'div',
            { style: styles.floatLeft },
            _react2.default.createElement(_Calendar2.default, {
              firstDayOfWeek: 1,
              maxDate: this.state.maxDate,
              initialDate: this.state.minDate,
              ref: 'minCalendar',
              showHourMinutesSilder: showHourMinutesSilder,
              getState: this.handleChangeMinDate.bind(this)
            })
          ),
          _react2.default.createElement(
            'div',
            { style: styles.floatLeft },
            _react2.default.createElement(_Calendar2.default, {
              firstDayOfWeek: 1,
              minDate: this.state.minDate,
              initialDate: this.state.maxDate,
              ref: 'maxCalendar',
              showHourMinutesSilder: showHourMinutesSilder,
              getState: this.handleChangeMaxDate.bind(this)
            })
          ),
          _react2.default.createElement('div', { style: styles.clear }),
          _react2.default.createElement(
            'div',
            { style: styles.footerToolContainerStyle },
            _react2.default.createElement(_RaisedButton2.default, { label: footerOkButtonText, primary: true, buttonStyle: styles.footerToolOkButtonStyle, onClick: this.setOnClick.bind(this) }),
            _react2.default.createElement(_RaisedButton2.default, { label: footerCancleButtonText, style: { marginLeft: '20px' }, buttonStyle: styles.footerToolCancleButtonStyle, onClick: this.onClose.bind(this) })
          )
        )
      );
    }
  }]);

  return ChoiceDatePickerDialog;
}(_react.Component);

ChoiceDatePickerDialog.contextTypes = {
  muiTheme: _react2.default.PropTypes.object.isRequired
};
exports.default = ChoiceDatePickerDialog;