#### DateTimePicker 时间范围选择器

* props

``` js
    /**
     * 初始时间,最好从组件提供的几个时间点来选择
     * @type {[string]}
     */
    initDate:React.PropTypes.any,
    /**
     * style时间范围区域的样式
     * @type {[type]}
     */
    style:React.PropTypes.object,
    /**
     * dialogSty;e弹出框的样式
     * @type {[type]}
     */
    dialogStyle:React.PropTypes.object,
    /**
     * 选择时间后触发事件
     * @type {[type]}
     * return 返回开始时间和结束时间
     */
    choiceDate:React.PropTypes.func
```

* 使用方法举例(伪代码)
``` js
import React from 'react';
import ChoiceDatePicker from 'COMPONENTS/DateTimePicker';
class MyComponet extends React.Component{
    choiceDate(beginDate，endDate){
        console.log(beginDate,endDate);
    }
    render(){
        const initDate = ['2017-02-12 12:00:00','2017-04-12 13:23:00'];
        //或者 const initDate = "近3小时";
        <ChoiceDatePicker
            style={{textAlign:'left'}}
            ref='ChoiceDatePicker'
            dialogStyle={{left:0}}
            initDate={initDate}
            choiceDate={this.choiceDate.bind(this)}
        \/>
    }
}
```
* 获取当前指定或者选择的时间
通过refs访问ChoiceDatePicker组件中的getSelectedTime方法，该方法返回开始时间和结束时间  
``` js
const selectTime = this.refs.ChoiceDatePicker.getSelectedTime();
```