'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _styleMerge = require('style-merge');

var _styleMerge2 = _interopRequireDefault(_styleMerge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @Author: eason
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @Date:   2016-10-08T17:06:58+08:00
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @Last modified by:   eason
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @Last modified time: 2016-12-12T18:18:01+08:00
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */

var Layout = function (_Component) {
  _inherits(Layout, _Component);

  function Layout() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Layout);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Layout.__proto__ || Object.getPrototypeOf(Layout)).call.apply(_ref, [this].concat(args))), _this), _this.style = {
      position: 'relative',

      // for self, as child
      // flex: '1 1 auto', // default
      order: '1', // default
      flexGrow: '1',
      flexShrink: '1',
      flexBasis: '0',

      // for children, as parent
      display: 'flex',
      flexWrap: 'nowrap', // fix
      flexDirection: 'row', // default
      justifyContent: 'space-around', // default
      alignItems: 'stretch', // default
      alignContent: 'flex-start', // default

      //
      overflow: 'hidden'
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Layout, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          component = _props.component,
          children = _props.children,
          style = _props.style,
          className = _props.className,
          vertical = _props.vertical,
          flexDirection = _props.flexDirection,
          justifyContent = _props.justifyContent,
          alignItems = _props.alignItems,
          alignContent = _props.alignContent,
          childrenOrders = _props.childrenOrders,
          childrenGrows = _props.childrenGrows,
          childrenShrinks = _props.childrenShrinks,
          childrenBasises = _props.childrenBasises,
          childrenStyle = _props.childrenStyle;
      var flexGrow = style.flexGrow,
          order = style.order;


      var Component = component ? component : 'div';

      var cls = (0, _classnames2.default)(_defineProperty({
        veui_layout: true
      }, className, className));

      var stl = (0, _styleMerge2.default)(this.style, style, {
        flexGrow: flexGrow || 1,
        order: order || 1,
        //
        flexDirection: vertical ? 'column' : 'row',
        justifyContent: justifyContent || style.justifyContent || 'space-around',
        alignItems: alignItems || style.alignItems || 'stretch',
        alignContent: alignContent || style.alignContent || 'flex-start'
      });

      // Not node
      if (typeof children === 'string') {
        return _react2.default.createElement(
          'div',
          { className: cls, style: stl },
          children
        );
      }

      return _react2.default.createElement(
        Component,
        {
          className: cls,
          style: stl },
        _react2.default.Children.map(children, function (child, index) {
          return !child ? child : _react2.default.cloneElement(child, {
            style: _extends({
              flexGrow: childrenGrows[index] || 1,
              flexShrink: childrenShrinks[index] || 1,
              flexBasis: childrenBasises[index] || 0,
              order: childrenOrders[index] || 1
            }, childrenStyle, child.props.style)
          });
        })
      );
    }
  }]);

  return Layout;
}(_react.Component);

Layout.propTypes = {
  /**
   * 子组件
   */
  children: _react.PropTypes.node,
  /**
   * 子组件放大分配比，例如childrenGrows={[1,2,2]}
   */
  childrenGrows: _react.PropTypes.arrayOf(_react.PropTypes.number),
  /**
   * 子组件缩小分配比,例如childrenShrinks={[2,1,1]}
   */
  childrenShrinks: _react.PropTypes.arrayOf(_react.PropTypes.number),
  /**
   * 子组件伸缩基准值
   */
  childrenBasises: _react.PropTypes.arrayOf(_react.PropTypes.number),
  /**
   * 控制伸缩项目在容器中的排列顺序
   */
  childrenOrders: _react.PropTypes.arrayOf(_react.PropTypes.number),
  /**
   * 子组件的样式
   */
  childrenStyle: _react.PropTypes.object,
  /**
   * 容器组件的样式
   */
  style: _react.PropTypes.object
};
Layout.defaultProps = {
  style: {},
  childrenGrows: [],
  childrenShrinks: [],
  childrenBasises: [],
  childrenOrders: [],
  childrenStyle: {}
};
exports.default = Layout;