/*
* @Author: fengbo
* @Date:   2017-04-28 13:03:40
* @Last Modified by:   fengbo
* @Last Modified time: 2017-05-03 13:40:39
*/

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUltimatePagination = require('react-ultimate-pagination');

var ReactUltimatePagination = _interopRequireWildcard(_reactUltimatePagination);

var _styleMerge = require('style-merge');

var _styleMerge2 = _interopRequireDefault(_styleMerge);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _FlatButton = require('material-ui/FlatButton');

var _FlatButton2 = _interopRequireDefault(_FlatButton);

var _firstPage = require('material-ui/svg-icons/navigation/first-page');

var _firstPage2 = _interopRequireDefault(_firstPage);

var _lastPage = require('material-ui/svg-icons/navigation/last-page');

var _lastPage2 = _interopRequireDefault(_lastPage);

var _chevronLeft = require('material-ui/svg-icons/navigation/chevron-left');

var _chevronLeft2 = _interopRequireDefault(_chevronLeft);

var _chevronRight = require('material-ui/svg-icons/navigation/chevron-right');

var _chevronRight2 = _interopRequireDefault(_chevronRight);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var bgColor = '#FFF';
var gotoStyle = {
  root: {
    display: 'inline-block',
    paddingLeft: '20px'
  },
  input: {
    margin: '0 8px',
    width: 48,
    height: 28,
    outline: 'none',
    border: '1px solid #D9D9D9',
    borderRadius: '2px',
    textAlign: 'center'
  }
};
var defaultStyle = {
  textAlign: 'center'
};

var flatButtonStyle = {
  minWidth: 28,
  background: bgColor
};

var activeStyle = {
  color: bgColor,
  background: '#2494F2'
};

//TODO:用户自定义跳转页码
var HandlerGotoPage = function HandlerGotoPage(event) {
  if (event.charCode === 13) {}
};

var Page = function Page(_ref) {
  var value = _ref.value,
      isActive = _ref.isActive,
      onClick = _ref.onClick;

  return _react2.default.createElement(_FlatButton2.default, {
    style: (0, _styleMerge2.default)(flatButtonStyle, isActive ? activeStyle : undefined),
    label: value.toString(),
    primary: isActive,
    onClick: onClick,
    hoverColor: bgColor,
    backgroundColor: bgColor,
    labelStyle: { fontSize: 12 }
  });
};

var Ellipsis = function Ellipsis(_ref2) {
  var value = _ref2.value,
      isActive = _ref2.isActive,
      onClick = _ref2.onClick;
  return _react2.default.createElement(_FlatButton2.default, { style: flatButtonStyle, label: '...', onClick: onClick });
};

var FirstPageLink = function FirstPageLink(_ref3) {
  var value = _ref3.value,
      isActive = _ref3.isActive,
      onClick = _ref3.onClick;
  return _react2.default.createElement(_FlatButton2.default, {
    style: (0, _styleMerge2.default)(flatButtonStyle, { display: 'none' }),
    label: '\u9996\u9875',
    onClick: onClick,
    labelStyle: { fontSize: 12, color: 'rgb(78, 78, 78)' }
  });
};

var PreviousPageLink = function PreviousPageLink(_ref4) {
  var value = _ref4.value,
      isActive = _ref4.isActive,
      onClick = _ref4.onClick;
  return _react2.default.createElement(_FlatButton2.default, {
    style: flatButtonStyle,
    label: '',
    icon: _react2.default.createElement(_chevronLeft2.default, null),
    onClick: onClick,
    labelStyle: { fontSize: 12, color: 'rgb(78, 78, 78)' }
  });
};

var NextPageLink = function NextPageLink(_ref5) {
  var value = _ref5.value,
      isActive = _ref5.isActive,
      onClick = _ref5.onClick;
  return _react2.default.createElement(_FlatButton2.default, {
    style: flatButtonStyle,
    label: '',
    icon: _react2.default.createElement(_chevronRight2.default, null),
    onClick: onClick,
    labelStyle: { fontSize: 12, color: 'rgb(78, 78, 78)' }
  });
};

var LastPageLink = function LastPageLink(_ref6) {
  var value = _ref6.value,
      isActive = _ref6.isActive,
      onClick = _ref6.onClick;
  return _react2.default.createElement(_FlatButton2.default, {
    style: (0, _styleMerge2.default)(flatButtonStyle, { display: 'none' }),
    label: '\u5C3E\u9875',
    onClick: onClick,
    labelStyle: { fontSize: 12, color: 'rgb(78, 78, 78)' }
  });
};

var TotalPage = function TotalPage(_ref7) {
  var total = _ref7.total;
  return _react2.default.createElement(
    'span',
    { style: { paddingLeft: '20px', fontSize: 12 } },
    '\u5171  ' + (total ? total : 1) + '  \u9875'
  );
};
var GotoPage = function GotoPage(_ref8) {
  var HandlerGotoPage = _ref8.HandlerGotoPage;

  return _react2.default.createElement(
    'div',
    { style: gotoStyle.root },
    _react2.default.createElement(
      'span',
      null,
      '\u8DF3\u81F3'
    ),
    _react2.default.createElement('input', { style: gotoStyle.input, onKeyPress: HandlerGotoPage, type: 'text' }),
    _react2.default.createElement(
      'span',
      null,
      '\u9875'
    )
  );
};
var WrapperComponent = function WrapperComponent(props) {
  var total = props.children[props.children.length - 1].props.value;
  return _react2.default.createElement(
    'div',
    { style: defaultStyle },
    props.children,
    _react2.default.createElement(TotalPage, { total: total }),
    _react2.default.createElement(GotoPage, { HandlerGotoPage: HandlerGotoPage })
  );
};

var itemTypeToComponent = {
  'PAGE': Page,
  'ELLIPSIS': Ellipsis,
  'FIRST_PAGE_LINK': FirstPageLink,
  'PREVIOUS_PAGE_LINK': PreviousPageLink,
  'NEXT_PAGE_LINK': NextPageLink,
  'LAST_PAGE_LINK': LastPageLink
};

exports.default = ReactUltimatePagination.createUltimatePagination({
  itemTypeToComponent: itemTypeToComponent,
  WrapperComponent: WrapperComponent
});